glibmm: Gio::UnixOutputStream Class Reference

glibmm 2.82.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gio::UnixOutputStream Class Reference
Stream Classes

UnixOutputStream implements OutputStream for writing to a a unix file descriptor, including asynchronous operations. More...

`#include <giomm/unixoutputstream.h>`

Inheritance diagram for Gio::UnixOutputStream:
[legend]

## Public Member Functions
| UnixOutputStream (UnixOutputStream &&src) noexcept
UnixOutputStream & | operator= (UnixOutputStream &&src) noexcept
| ~UnixOutputStream () noexcept override
GUnixOutputStream * | gobj ()
| Provides access to the underlying C GObject.
const GUnixOutputStream * | gobj () const
| Provides access to the underlying C GObject.
GUnixOutputStream * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
void | set_close_fd (bool close_fd=true)
| Sets whether the file descriptor of stream shall be closed when the stream is closed.
bool | get_close_fd () const
| Returns whether the file descriptor of stream will be closed when the stream is closed.
int | get_fd () const
| Return the UNIX file descriptor that the stream writes to.
Glib::PropertyProxy_ReadOnly< int > | property_fd () const
| The file descriptor that the stream writes to.
Glib::PropertyProxy< bool > | property_close_fd ()
| Whether to close the file descriptor when the stream is closed.
Glib::PropertyProxy_ReadOnly< bool > | property_close_fd () const
| Whether to close the file descriptor when the stream is closed.
Public Member Functions inherited from Gio::OutputStream
| OutputStream (OutputStream &&src) noexcept
OutputStream & | operator= (OutputStream &&src) noexcept
| ~OutputStream () noexcept override
GOutputStream * | gobj ()
| Provides access to the underlying C GObject.
const GOutputStream * | gobj () const
| Provides access to the underlying C GObject.
GOutputStream * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
gssize | write (const void *buffer, gsize count, const Glib::RefPtr< Cancellable > &cancellable)
| Tries to write count bytes from buffer into the stream.
gssize | write (const void *buffer, gsize count)
| A write() convenience overload.
gssize | write (const std::string &buffer, const Glib::RefPtr< Cancellable > &cancellable)
| Tries to write count bytes from buffer into the stream.
gssize | write (const std::string &buffer)
| Tries to write count bytes from buffer into the stream.
bool | write_all (const void *buffer, gsize count, gsize &bytes_written, const Glib::RefPtr< Cancellable > &cancellable)
| Tries to write count bytes from buffer into the stream.
bool | write_all (const void *buffer, gsize count, gsize &bytes_written)
| A write_all() convenience overload.
bool | write_all (const std::string &buffer, gsize &bytes_written, const Glib::RefPtr< Cancellable > &cancellable)
| Tries to write count bytes from buffer into the stream.
bool | write_all (const std::string &buffer, gsize &bytes_written)
| Tries to write count bytes from buffer into the stream.
gssize | write_bytes (const Glib::RefPtr< const Glib::Bytes > & bytes, const Glib::RefPtr< Cancellable > &cancellable)
| A wrapper function for g_output_stream_write() which takes a Bytes as input.
gssize | write_bytes (const Glib::RefPtr< const Glib::Bytes > & bytes)
| A write_bytes() convenience overload.
void | write_bytes_async (const Glib::RefPtr< const Glib::Bytes > & bytes, const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > &cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous write of the data in bytes to the stream.
void | write_bytes_async (const Glib::RefPtr< const Glib::Bytes > & bytes, const SlotAsyncReady & slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous write of the data in bytes to the stream.
gssize | write_bytes_finish (const Glib::RefPtr< AsyncResult > &result)
| Finishes a stream write-from-Bytes operation.
gssize | splice (const Glib::RefPtr< InputStream > &source, const Glib::RefPtr< Cancellable > &cancellable, SpliceFlags flags=SpliceFlags::NONE)
| Splices an input stream into an output stream.
gssize | splice (const Glib::RefPtr< InputStream > &source, SpliceFlags flags=SpliceFlags::NONE)
| Splices an input stream into an output stream.
bool | flush (const Glib::RefPtr< Cancellable > &cancellable)
| Flushed any outstanding buffers in the stream.
bool | flush ()
| A flush() convenience overload.
bool | close (const Glib::RefPtr< Cancellable > &cancellable)
| Closes the stream, releasing resources related to it.
bool | close ()
| A close() convenience overload.
void | write_async (const void *buffer, gsize count, const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > &cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous write of count bytes from buffer into the stream.
void | write_async (const void *buffer, gsize count, const SlotAsyncReady & slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous write of count bytes from buffer into the stream.
gssize | write_finish (const Glib::RefPtr< AsyncResult > &result)
| Finishes a stream write operation.
void | write_all_async (const void *buffer, gsize count, const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > &cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous write of count bytes from buffer into the stream.
void | write_all_async (const void *buffer, gsize count, const SlotAsyncReady & slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous write of count bytes from buffer into the stream.
bool | write_all_finish (const Glib::RefPtr< AsyncResult > &result, gsize &bytes_written)
| Finishes an asynchronous stream write operation started with g_output_stream_write_all_async().
void | splice_async (const Glib::RefPtr< InputStream > &source, const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > &cancellable, SpliceFlags flags=SpliceFlags::NONE, int io_priority=Glib::PRIORITY_DEFAULT)
| Splices a stream asynchronously.
void | splice_async (const Glib::RefPtr< InputStream > &source, const SlotAsyncReady & slot, SpliceFlags flags=SpliceFlags::NONE, int io_priority=Glib::PRIORITY_DEFAULT)
| Splices a stream asynchronously.
gssize | splice_finish (const Glib::RefPtr< AsyncResult > &result)
| Finishes an asynchronous stream splice operation.
void | flush_async (const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > &cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Flushes a stream asynchronously.
void | flush_async (const SlotAsyncReady & slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Flushes a stream asynchronously.
bool | flush_finish (const Glib::RefPtr< AsyncResult > &result)
| Finishes flushing an output stream.
void | close_async (const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > &cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Requests an asynchronous close of the stream, releasing resources related to it.
void | close_async (const SlotAsyncReady & slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Requests an asynchronous close of the stream, releasing resources related to it.
bool | close_finish (const Glib::RefPtr< AsyncResult > &result)
| Closes an output stream.
bool | is_closed () const
| Checks if an output stream has already been closed.
bool | is_closing () const
| Checks if an output stream is being closed.
bool | has_pending () const
| Checks if an output stream has pending actions.
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark & key)
void | set_data (const Quark & key, void *data)
void | set_data_with_c_callback (const Quark & key, void *data, GDestroyNotify notify)
void | set_data (const Quark & key, void *data, DestroyNotify notify)
| Prefer set_data_with_c_callback() with a callback with C linkage.
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring & property_name, const Glib::ValueBase & value)
| You probably want to use a specific property_*() accessor method instead.
void | get_property_value (const Glib::ustring & property_name, Glib::ValueBase & value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | set_property (const Glib::ustring & property_name, const PropertyType & value)
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | get_property (const Glib::ustring & property_name, PropertyType & value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
PropertyType | get_property (const Glib::ustring & property_name) const
| You probably want to use a specific property_*() accessor method instead.
sigc::connection | connect_property_changed (const Glib::ustring & property_name, const sigc::slot< void()> & slot)
| You can use the signal_changed() signal of the property proxy instead.
sigc::connection | connect_property_changed (const Glib::ustring & property_name, sigc::slot< void()> && slot)
| You can use the signal_changed() signal of the property proxy instead.
void | freeze_notify ()
| Increases the freeze count on object.
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify().
virtual void | reference () const
| Increment the reference count for this object.
virtual void | unreference () const
| Decrement the reference count for this object.
GObject * | gobj ()
| Provides access to the underlying C GObject.
const GObject * | gobj () const
| Provides access to the underlying C GObject.
GObject * | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access.
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const
Public Member Functions inherited from Gio::PollableOutputStream
| PollableOutputStream (PollableOutputStream &&src) noexcept
PollableOutputStream & | operator= (PollableOutputStream &&src) noexcept
| ~PollableOutputStream () noexcept override
GPollableOutputStream * | gobj ()
| Provides access to the underlying C GObject.
const GPollableOutputStream * | gobj () const
| Provides access to the underlying C GObject.
bool | can_poll () const
| Checks if stream is actually pollable.
bool | is_writable () const
| Checks if stream can be written.
gssize | write_nonblocking (const void *buffer, gsize count, const Glib::RefPtr< Cancellable > &cancellable)
| Attempts to write up to count bytes from buffer to stream, as with g_output_stream_write().
gssize | write_nonblocking (const void *buffer, gsize count)
| A write_nonblocking() convenience overload.
Public Member Functions inherited from Glib::Interface
| Interface ()
| A Default constructor.
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Called by constructors of derived classes.
| Interface (GObject *castitem)
| Called by constructors of derived classes.
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const
Public Member Functions inherited from Gio::FileDescriptorBased
| FileDescriptorBased (FileDescriptorBased &&src) noexcept
FileDescriptorBased & | operator= (FileDescriptorBased &&src) noexcept
| ~FileDescriptorBased () noexcept override
GFileDescriptorBased * | gobj ()
| Provides access to the underlying C GObject.
const GFileDescriptorBased * | gobj () const
| Provides access to the underlying C GObject.
int | get_fd () const
| Gets the underlying file descriptor.

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< UnixOutputStream > | create (int fd, bool close_fd)
Static Public Member Functions inherited from Gio::OutputStream
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gio::PollableOutputStream
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gio::FileDescriptorBased
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Protected Member Functions
| UnixOutputStream (int fd, bool close_fd)
Protected Member Functions inherited from Gio::OutputStream
| OutputStream ()
bool | set_pending ()
| Sets stream to have actions pending.
void | clear_pending ()
| Clears the pending flag on stream.
virtual gssize | write_vfunc (const void *buffer, gsize count, const Glib::RefPtr< Cancellable > &cancellable)
virtual gssize | splice_vfunc (const Glib::RefPtr< InputStream > &source, const Glib::RefPtr< Cancellable > &cancellable, SpliceFlags flags)
virtual bool | flush_vfunc (const Glib::RefPtr< Cancellable > &cancellable)
virtual bool | close_vfunc (const Glib::RefPtr< Cancellable > &cancellable)
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor.
| ObjectBase (const char *custom_type_name)
| A derived constructor always overrides this choice.
| ObjectBase (const std::type_info &custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually.
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)
Protected Member Functions inherited from Gio::PollableOutputStream
| PollableOutputStream ()
| You should derive from this class to use it.
virtual bool | can_poll_vfunc () const
virtual bool | is_writable_vfunc () const
virtual gssize | write_nonblocking_vfunc (const void *buffer, gsize count)
Protected Member Functions inherited from Gio::FileDescriptorBased
| FileDescriptorBased ()
| You should derive from this class to use it.
virtual int | get_fd_vfunc () const

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gio::UnixOutputStream > | wrap (GUnixOutputStream *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gio::OutputStream
Glib::RefPtr< Gio::OutputStream > | wrap (GOutputStream *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Related Symbols inherited from Gio::PollableOutputStream
Glib::RefPtr< Gio::PollableOutputStream > | wrap (GPollableOutputStream *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gio::FileDescriptorBased
Glib::RefPtr< Gio::FileDescriptorBased > | wrap (GFileDescriptorBased *object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Public Types inherited from Gio::OutputStream
enum class | SpliceFlags { SpliceFlags::NONE = 0x0 , SpliceFlags::CLOSE_SOURCE = (1 << 0) , SpliceFlags::CLOSE_TARGET = (1 << 1) }
| GOutputStreamSpliceFlags determine how streams should be spliced. More...
Public Types inherited from Glib::Object
using | DestroyNotify = void(*)(gpointer data)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

UnixOutputStream implements OutputStream for writing to a a unix file descriptor, including asynchronous operations.

The file descriptor much be selectable, so it doesn't work with opened files.

Since glibmm 2.16:

## Constructor & Destructor Documentation

## ◆ UnixOutputStream() [1/2]

Gio::UnixOutputStream::UnixOutputStream | ( | UnixOutputStream && | src | ) |
| noexcept

## ◆ ~UnixOutputStream()

Gio::UnixOutputStream::~UnixOutputStream | ( |  | ) |
| overridenoexcept

## ◆ UnixOutputStream() [2/2]

Gio::UnixOutputStream::UnixOutputStream | ( | int | fd,
|  | bool | close_fd
| ) |  |
| explicitprotected

## Member Function Documentation

## ◆ create()

static Glib::RefPtr< UnixOutputStream > Gio::UnixOutputStream::create | ( | int | fd,
|  | bool | close_fd
| ) |  |
| static

## ◆ get_close_fd()

bool Gio::UnixOutputStream::get_close_fd | ( |  | ) | const

Returns whether the file descriptor of stream will be closed when the stream is closed.

Since glibmm 2.20:

Returns
  `true` if the file descriptor is closed when done.

## ◆ get_fd()

int Gio::UnixOutputStream::get_fd | ( |  | ) | const

Return the UNIX file descriptor that the stream writes to.

Since glibmm 2.20:

Returns
  The file descriptor of stream.

## ◆ get_type()

static GType Gio::UnixOutputStream::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GUnixOutputStream * Gio::UnixOutputStream::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GUnixOutputStream * Gio::UnixOutputStream::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GUnixOutputStream * Gio::UnixOutputStream::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

UnixOutputStream & Gio::UnixOutputStream::operator= | ( | UnixOutputStream && | src | ) |
| noexcept

## ◆ property_close_fd() [1/2]

Glib::PropertyProxy< bool > Gio::UnixOutputStream::property_close_fd | ( |  | ) |

Whether to close the file descriptor when the stream is closed.

Since glibmm 2.20:

Default value: `true`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_close_fd() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gio::UnixOutputStream::property_close_fd | ( |  | ) | const

Whether to close the file descriptor when the stream is closed.

Since glibmm 2.20:

Default value: `true`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_fd()

Glib::PropertyProxy_ReadOnly< int > Gio::UnixOutputStream::property_fd | ( |  | ) | const

The file descriptor that the stream writes to.

Since glibmm 2.20:

Default value: -1

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ set_close_fd()

void Gio::UnixOutputStream::set_close_fd | ( | bool | close_fd = `true` | ) |

Sets whether the file descriptor of stream shall be closed when the stream is closed.

Since glibmm 2.20:

Parameters

  close_fd | `true` to close the file descriptor when done.

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gio::UnixOutputStream > wrap | ( | GUnixOutputStream * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.